//
// Created by skygrow on 5/14/25.
//

#ifndef XMLSTORAGE_H
#define XMLSTORAGE_H

#include "pugixml.hpp"

namespace AtmAdmin {
    class XMLStorage {
    public:
        explicit XMLStorage (const std::string& search) : m_search(search) {
            initXMLDoc();

            pugi::xml_node accountData {(getXMLUserData(search))};

            this->name  ={accountData.child_value("name") };
            this->pin   ={std::stoi(accountData.child_value("pin"))  };
        }

        void initXMLDoc ();
        pugi::xml_node getXMLUserData (const std::string& toSearch);

        std::string name{};
        int pin{};

        // ~XMLStorage() {
        //     updateXMLData(m_search);
        // }

    private:
        // void updateXMLData (const std::string& toSearch); // Is currently unused.
        pugi::xml_document m_doc;
        const std::string m_search;
    };
}

#endif //XMLSTORAGE_H
